import numpy as np

# Limites para parámetros de entrada
min_numProducts =4
max_numProducts = 4
min_processing_time = 1
max_processing_time = 3
min_configuration_time = 6
max_configuration_time = 10
min_conf_cost = 25
max_conf_cost = 35
min_production_cost = 2
max_production_cost = 5
min_deferring_cost = 20
max_deferring_cost = 30
min_Initial_Inventary = 0
max_Initial_Inventary = 0
min_holding_cost_product = 5
max_holding_cost_product = 10
min_demand = 15
max_demand = 35
numMachines = 3
numPeriods = 3
code = '3_2_1'
folder = 'data/'

# Notas:
# Después de generar los datos, es necesario agregar manualmente ciertos datos después del cálculo de generación de datos:
# - Inventario de Materia Prima: Asegúrese de agregar el inventario de materia prima en su archivo correspondiente.
# - BOM (Lista de Materiales): La tasa de consumo de los materiales debe ser añadida manualmente en el archivo BOM correspondiente.
# - Capacidad de las máquinas

def line_prepender(filename, line):
    with open(filename, 'r+') as f:
        content = f.read()
        f.seek(0, 0)
        f.write(line.rstrip('\r\n') + '\n' + content)


# Generar números aleatorios para la cantidad de productos
numProducts = np.random.randint(low=min_numProducts, high=max_numProducts + 1)
numRawmaterials = numProducts

# Generar identificadores únicos para los productos
product_ids = np.arange(1, numProducts + 1)
rawmaterial_ids = np.arange(1, numRawmaterials + 1)

# Inicializar matrices para almacenar los datos
num_periods = np.arange(1, numPeriods + 1).reshape(-1, 1)
num_machines = np.arange(1, numMachines + 1).reshape(-1, 1)
demands = np.zeros((numProducts * numPeriods, 3), dtype=int)
processing_data = np.zeros((numProducts * numMachines, 5), dtype=float)
Initial_Inventary = np.zeros((numProducts, 2), dtype=int)
deferring_cost = np.zeros((numProducts, 2), dtype=int)
holding_cost = np.zeros((numProducts, 2), dtype=int)
rawmaterial_data = np.zeros((numRawmaterials, 2), dtype=int)
bom_data = np.zeros((numRawmaterials * numProducts, 3), dtype=int)
data_machine = np.zeros((numMachines, 3), dtype=int)
data_production = np.zeros((numProducts * numMachines * numPeriods, 4), dtype=int)
data_P = np.zeros((numProducts * numMachines * numPeriods, 4), dtype=int)
data_dpm = np.zeros((numMachines * numPeriods, 3), dtype=int)
data_mpf = np.zeros((numRawmaterials, 3), dtype=int)

# Llenar las matrices con datos aleatorios
row = 0
for i in range(numProducts):
    for t in range(numPeriods):
        demand = np.random.randint(min_demand, max_demand + 1)
        product_id = product_ids[i]
        period = t + 1
        demands[row, 0] = product_id
        demands[row, 1] = period
        demands[row, 2] = demand
        row += 1

row = 0
for i in range(numProducts):
    for j in range(numMachines):
        product_id = product_ids[i]
        machine_id = j + 1
        processing_time = np.random.uniform(min_processing_time, max_processing_time)
        production_cost = np.random.randint(min_production_cost, max_production_cost + 1)
        configuration_time = np.random.uniform(min_configuration_time, max_configuration_time)

        processing_data[row, 0] = product_id
        processing_data[row, 1] = machine_id
        processing_data[row, 2] = processing_time
        processing_data[row, 3] = production_cost
        processing_data[row, 4] = configuration_time

        row += 1

row = 0
for j in range(numMachines):
    machine_id = j + 1
    configuration_cost = np.random.randint(min_conf_cost, max_conf_cost + 1)

    data_machine[row, 0] = machine_id
    data_machine[row, 1] = 0
    data_machine[row, 2] = configuration_cost

    row += 1

row = 0
for i in range(numProducts):
    product_id = product_ids[i]
    initial_inventory_product = np.random.randint(min_Initial_Inventary, max_Initial_Inventary + 1)

    Initial_Inventary[row, 0] = product_id
    Initial_Inventary[row, 1] = initial_inventory_product

    row += 1

row = 0
for i in range(numProducts):
    product_id = product_ids[i]
    deferring_cost_product = np.random.randint(min_deferring_cost, max_deferring_cost + 1)

    deferring_cost[row, 0] = product_id
    deferring_cost[row, 1] = deferring_cost_product

    row += 1

row = 0
for i in range(numProducts):
    product_id = product_ids[i]
    holding_cost_product = np.random.randint(min_holding_cost_product, max_holding_cost_product + 1)

    holding_cost[row, 0] = product_id
    holding_cost[row, 1] = holding_cost_product

    row += 1

row = 0
for r in range(numRawmaterials):
    rawmaterial_id = rawmaterial_ids[r]
    inventary_value = 0

    rawmaterial_data[row, 0] = rawmaterial_id
    rawmaterial_data[row, 1] = inventary_value

    row += 1

row = 0
for r in rawmaterial_ids:
    for i in product_ids:
        bom_data[row, 0] = r
        bom_data[row, 1] = i
        bom_data[row, 2] = 0

        row += 1

row = 0
for i in range(numProducts):
    for j in range(numMachines):
        for t in range(numPeriods):
            product_id = product_ids[i]
            machine_id = j + 1
            period_id = t + 1
            value = 0

            data_production[row, 0] = product_id
            data_production[row, 1] = machine_id
            data_production[row, 2] = period_id
            data_production[row, 3] = value

            data_P[row, 0] = product_id
            data_P[row, 1] = machine_id
            data_P[row, 2] = period_id
            data_P[row, 3] = value

            row += 1

row = 0
for j in range(numMachines):
    for t in range(numPeriods):
        machine_id = j + 1
        period_id = t + 1
        dpm_value = 0

        data_dpm[row, 0] = machine_id
        data_dpm[row, 1] = period_id
        data_dpm[row, 2] = dpm_value

        row += 1

row = 0
for r in range(numRawmaterials):
    rawmaterial_id = rawmaterial_ids[r]
    value = 0

    data_mpf[row, 0] = rawmaterial_id
    data_mpf[row, 1] = value
    data_mpf[row, 2] = value

    row += 1

# Guardar datos en archivos
num_periods_filename = folder + code + '/input/Periods.tab'
num_machines_filename = folder + code + '/input/Machines.tab'
ID_filename = folder + code + '/input/Products.tab'
data_machine_filename = folder + code + '/input/Machine_Data.tab'
processing_data_filename = folder + code + '/input/Production_Requirements.tab'
demands_filename = folder + code + '/input/Demand.tab'
Initial_Inventary_filename = folder + code + '/input/Initial_Inventory_Products.tab'
deferring_cost_filename = folder + code + '/input/deferring_cost.tab'
holding_cost_filename = folder + code + '/input/HoldingCost_Product.tab'
rawmaterial_filename = folder + code + '/input/Initial_Inventory_RawMaterial.tab'
bom_filename = folder + code + '/input/BOM.tab'
data_production_filename = folder + code + '/input/Produced.tab'
data_P_filename = folder + code + '/input/InProcess_Products.tab'
data_dpm_filename = folder + code + '/input/Status_Machine.tab'
data_mpf_filename = folder + code + '/input/MPF.tab'

np.savetxt(num_periods_filename, num_periods, fmt='%i', delimiter='\t')
np.savetxt(num_machines_filename, num_machines, fmt='%i', delimiter='\t')
np.savetxt(ID_filename, product_ids, fmt='%i', delimiter='\t')
np.savetxt(data_machine_filename, data_machine, fmt='%i', delimiter='\t')
np.savetxt(processing_data_filename, processing_data, fmt='%i', delimiter='\t')
np.savetxt(demands_filename, demands, fmt='%i', delimiter='\t')
np.savetxt(Initial_Inventary_filename, Initial_Inventary, fmt='%i', delimiter='\t')
np.savetxt(deferring_cost_filename, deferring_cost, fmt='%i', delimiter='\t')
np.savetxt(holding_cost_filename, holding_cost, fmt='%i', delimiter='\t')
np.savetxt(rawmaterial_filename, rawmaterial_data, fmt='%i', delimiter='\t')
np.savetxt(bom_filename, bom_data, fmt='%i', delimiter='\t')
np.savetxt(data_production_filename, data_production, fmt='%i', delimiter='\t')
np.savetxt(data_P_filename, data_P, fmt='%i', delimiter='\t')
np.savetxt(data_dpm_filename, data_dpm, fmt='%i', delimiter='\t')
np.savetxt(data_mpf_filename, data_mpf, fmt='%i', delimiter='\t')

# Agregar encabezados a los archivos
line_prepender(num_periods_filename, 'IdPeriod')
line_prepender(num_machines_filename, 'IdMachine')
line_prepender(ID_filename, 'IdProduct')
line_prepender(data_machine_filename, 'IdMachine\tCapacity\tConfcost')
line_prepender(processing_data_filename, 'IdProduct\tMachineId\tProcessingTime\tProductionCost\tConfigurationTime')
line_prepender(demands_filename, 'IdProduct\tPeriod\tDemand')
line_prepender(Initial_Inventary_filename, 'IdProduct\tQuantity')
line_prepender(deferring_cost_filename, 'IdProduct\tdeferringcost')
line_prepender(holding_cost_filename, 'IdProduct\tholdingcost')
line_prepender(rawmaterial_filename, 'IdRawMaterial\tInvIR')
line_prepender(bom_filename, 'IdRawMaterial\tIdProduct\tUtilrate')
line_prepender(data_production_filename, 'IdProduct\tIdMachine\tIdPeriod\tPb')
line_prepender(data_P_filename, 'IdProduct\tIdMachine\tIdPeriod\tP')
line_prepender(data_dpm_filename, 'IdMachine\tIdPeriod\tSm')
line_prepender(data_mpf_filename, 'IdRawMaterial\tIdPeriod\tQuantity')

print(f"Archivos guardados en la carpeta '{folder}'")

